﻿using System;

using Facade.Buildings;

using ThirdParty;

namespace Facade.Adapters
{
    public class StructureAdapter : IBuilding
    {
        private Structure _structure;

        public StructureAdapter(Structure structure)
        {
            _structure = structure;
        }

        public string Description
        {
            get { return _structure.Description; }
        }

        public int Power
        {
            get { return _structure.CurrentEnergyUsage; }
        }

        public bool ConsumesPower
        {
            get
            {
                return (_structure.CurrentEnergyUsage == 0);
            }
            set
            {
                if (!value)
                {
                    _structure.PowerDownStructure();
                }
                else
                {
                    _structure.PowerUpStructure();
                }
            }
        }
    }
}
