﻿using System;

using Facade.Units;
using Facade.FactionInfo;
using Facade.FactionInfo.NOD;

namespace Facade.Buildings.NOD
{
    public class HandOfNod : InfantryFactory, IBuilding
    {
        public HandOfNod()
        {
            ConsumesPower = true;
        }

        protected override GameUnit CreateUnit(UnitType type)
        {
            // Create faction factory
            FactionDetailsFactory nodFactory = new NodDetails();

            switch (type)
            {
                case UnitType.Soldier: return new Soldier(nodFactory);
                case UnitType.Engineer: return new Engineer(nodFactory);
                case UnitType.EliteUnit: return new EliteUnit(nodFactory);
                default: return null;
            }
        }

        public string Description
        {
            get { return "Barracks"; }
        }

        public int Power
        {
            get { return 10; }
        }

        public bool ConsumesPower { get; set; }
    }
}
